#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/fcntl.h>
#include <stropts.h>
#include <errno.h>
#include <sys/vuid_event.h>

/* pass FULL BUFFER of 5, and we will print it out */
void print5(char *buffer){
	printf(" type 1: %d,%d,%d,%d\n",
	       buffer[1],buffer[2],buffer[3],buffer[4]);
}

/* pass FULL BUFFER of 8, and we will print it out */
void print8(unsigned char *buffer){
	unsigned int x, y;
	unsigned int pressure;
	int stats=buffer[1];

	x=(buffer[3]<<8)|buffer[2];
	y=(buffer[5]<<8)|buffer[4];
	pressure=(buffer[7]<<8)|buffer[6];
	
	printf(" type 2(%2x.%2x): X=%d,Y=%d,Pressure=%d: ",
	       buffer[0],buffer[1], x,y,pressure);

	if(stats&0x01){
		printf("button1 ");
	}
	if(stats&0x02){
		printf("button3(rightbutton) ");
	}
	if(stats&0x04){
		printf("button2(middlebutton) ");
	}
	/* stats&0x10 == "vaguely close, dont know what type it is"
	 * stats&0x90 = "close, and we can now identify device"
	 */
	switch(stats&0x60){
		case 0x00:
			puts("PEN");
			break;
		case 0x20:
			puts("ERASER");
			break;
		case 0x40:
			puts("MOUSE");
			break;
	}

}


int main(int argc, char *argv[]){
	int fd,bytes;
	char buffer[10];
	if(argc<2){
		puts("Need a device name to hold open");
		exit(1);
	}
	fd=open(argv[1],O_RDONLY);
	if(fd<0){
		perror("could not open file");
		exit(1);
	}
	while(1){
	

#ifdef USE_NREAD
		if(ioctl(fd,I_NREAD,&bytes)!=0){
			perror("ioctl failed\n");
			return (errno);
		}
		if(bytes<=0){
			continue;
		}
		printf("bytes ready: %d\n",bytes);
#else
		/* hardcode for graphire testing */
		bytes=8;
#endif

		while(bytes>0){
		if(read(fd,buffer,1)!=1){
			perror("initial read failed\n");
			exit(errno);
		}
		bytes-= 1;
		
		switch(buffer[0]){
			case 1:
			read(fd,&buffer[1],4);
			print5(buffer);
			bytes -=4;
			break;

			case 2:
			read(fd,&buffer[1],7);
			print8(buffer);
			bytes-=7;
			break;

			default:
			printf("Unrecognized data type %d\n",buffer[0]);
			break;
		}
		}
	}

	/* NOTREACHED */
	puts("quitting");
	close(fd);
	
}
